if not (Klappa) then return; end;
local _G = getfenv(0);

local Klappa = Klappa;

local AceOO = AceLibrary("AceOO-2.0")
Klappa.PopUpButton = AceOO.Class("AceEvent-2.0");

function Klappa.PopUpButton.prototype:init(parent, indx, type)
	Klappa.PopUpButton.super.prototype.init(self);
	
	self.index = indx;
	self.id = parent.index..indx
	self.parent = parent;
	self.button = CreateFrame("CheckButton", "Klappa"..type.."PopUpButton"..indx, parent.button, "SecureAnchorUpDownTemplate,SecureActionButtonTemplate,ActionButtonTemplate");
	self.button:SetWidth(36);
	self.button:SetHeight(36);
	self.button.texture = self.button:CreateTexture(nil, "BACKGROUND");
	self.button.texture:SetAllPoints(self.button);
	self.button.texture:SetTexture(GetSpellTexture(""));
	self.button:SetCheckedTexture("");
	self.button:SetNormalTexture("");
	self:ApplyStyle();
	self.button.texture:SetPoint("TOPLEFT", self.button, "TOPLEFT", 3, -3);
	self.button.texture:SetPoint("BOTTOMRIGHT", self.button, "BOTTOMRIGHT",  -3, 3);
	self.button.texture:SetTexCoord(0.08, 0.92, 0.08, 0.92);
	self.button:SetAttribute("type", "spell");
	self.button:SetAttribute("spell", "");
	self.button.Spell = "";
	self.button:SetAttribute("anchorchild", parent.frame);
	self.button:SetAttribute("showstates", tostring(parent.index));
	Klappa.root:SetAttribute("addchild", self.button);
	
	self.button:SetScript("OnEnter", function(b) Klappa:ShowTooltip(b); end);
	self.button:SetScript("OnLeave", function() Klappa:HideTooltip(); end);
	self.button:SetScript("OnDragStart", function() parent.popupButtons[indx]:ButtonDrag(); end);
	self.button:SetScript("OnReceiveDrag", function() parent.popupButtons[indx]:ButtonDrop(); end);
	self.button:RegisterForDrag("LeftButton");
	
	self.button.cooldown = _G[self.button:GetName().."Cooldown"];
	self:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN", "ButtonEventHandler")
	
	--Klappa.db.profile.buttons[self.parent.index].popupButtons[self.index] = {};
	
	Klappa:Debug("PopupName: "..self.button:GetName());
end

function Klappa.PopUpButton.prototype:UpdateLayout(isVert, isRtDn, x, y)
	Klappa:Debug(self.parent.button:GetName())
	Klappa:Debug("x: "..x.."  __  Y: "..y);
	if (isVert and isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("LEFT", self.parent.button, "RIGHT", x, y);
	elseif (isVert and not isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("RIGHT", self.parent.button, "LEFT", x, y);
	elseif (not isVert and isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("TOP", self.parent.button, "BOTTOM", x, y);
	elseif (not isVert and not isRtDn) then
		self.button:ClearAllPoints();
		self.button:SetPoint("BOTTOM", self.parent.button, "TOP", x, y);
	end
	self.button:SetAlpha(Klappa.db.profile.popupAlpha);
	self.button:SetScale(Klappa.db.profile.popupScale);
end

function Klappa.PopUpButton.prototype:ApplyStyle()
	local frame = CreateFrame("Frame", self.button:GetName().."DL", self.button);
	frame:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 1, edgeFile = "", edgeSize = 0, insets = {left = 0, right = 0, top = 0, bottom = 0},})
	frame:SetBackdropColor(0, 0, 0, 0.6)
	frame:SetAllPoints(self.button)
	frame:SetFrameLevel(0)
end

function Klappa.PopUpButton.prototype:UpdateCooldown()
	if (self.button.spellID and self.button.cooldown) then
	--	Klappa:Debug(self.button.type);
		if(self.button.type == "spell") then
		local start, duration, enable = GetSpellCooldown(self.button.spellID, BOOKTYPE_SPELL);
		CooldownFrame_SetTimer(self.button.cooldown, start, duration, enable)
	--		Klappa:Debug("Start:");
	--		Klappa:Debug(start);
	--		Klappa:Debug(duration);
	--		Klappa:Debug(enable);
		elseif(self.button.type == "item") then
			local start, duration, enable = GetItemCooldown(self.button.spellID);
			CooldownFrame_SetTimer(self.button.cooldown, start, duration, enable)
		end
	end
end

function Klappa.PopUpButton.prototype:ButtonEventHandler(e)
	if (event == "ACTIONBAR_UPDATE_COOLDOWN") then
		self:UpdateCooldown();
	end
end

function Klappa.PopUpButton.prototype:ButtonDrag()
	Klappa:Debug("drag");
	if(self.spell ~= "") then
		if(self.button.type == "spell") then
			Klappa:Debug("Drag ID");
			Klappa:Debug(self.spell);
			PickupSpell(self.spell);
			self.button:SetAttribute("spell1", "");
			self.spell = "";
			self.button.spellID = nil;
			self.button.texture:SetTexture("");
		elseif(self.button.type == "macro") then
			PickupMacro(self.spell);
			self.button:SetAttribute("spell1", "");
			self.button.spell = "";
			self.button.spellID = nil;
			self.button.texture:SetTexture("");
		else
			PickupSpell(self.spell);
			self.button:SetAttribute("spell1", "");
			self.button.spell = "";
			self.button.spellID = nil;
			self.button.texture:SetTexture("");
		end
	end
end

function Klappa.PopUpButton.prototype:ButtonDrop()
	Klappa:Debug("drop");
	spelltype, slot = GetCursorInfo()
	if(spelltype == nil or slot == nil) then return end;
	
	self.button.spellID = slot;
	self.button.type = spelltype;
	Klappa:Debug("Spell:"..spelltype.."  slot: "..slot);
	if(Klappa.db.profile.buttons[self.parent.index] == nil) then
		Klappa.db.profile.buttons[self.parent.index] = {};
	end
	
	if(Klappa.db.profile.buttons[self.parent.index].popupButtons == nil) then
		Klappa.db.profile.buttons[self.parent.index].popupButtons = {};
	end
	
	Klappa.db.profile.buttons[self.parent.index].popupButtons[self.index] = {};
	local curtexture = "";
	self.button:SetAttribute("*type*", spelltype);
	
	if(CursorHasSpell()) then
		local spellName, spellRank = GetSpellName(slot, BOOKTYPE_SPELL)
		self.spellName = spellName;
		self.spell = spellName.."("..spellRank..")";

		curtexture = GetSpellTexture(slot,BOOKTYPE_SPELL);
		self.button.texture:SetTexture(curtexture);
		self.button:SetAttribute(spelltype.."1", spellName.."("..spellRank..")");
		Klappa.db.profile.buttons[self.parent.index].popupButtons[self.index].spell = spellName.."("..spellRank..")";
		Klappa:Debug("is spell");
	elseif(CursorHasItem()) then
		local spellName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, itemEquipLoc, texture = GetItemInfo(slot);
		self.spellName = spellName;
		self.spell = spellName;
		self.button:SetAttribute(spelltype.."1", spellName);
		self.button.texture:SetTexture(texture);
		curtexture = texture;
		Klappa.db.profile.buttons[self.parent.index].popupButtons[self.index].spell = spellName;
	elseif(CursorHasMacro()) then
		local spellName, texture, macrobody, localVar = GetMacroInfo(slot)
		self.spellName = spellName;
		self.spell = spellName;
		self.button:SetAttribute(spelltype.."1", spellName);
		self.button.texture:SetTexture(texture);
		curtexture = texture;
		Klappa.db.profile.buttons[self.parent.index].popupButtons[self.index].spell = spellName;
	end
	
	Klappa.db.profile.buttons[self.parent.index].popupButtons[self.index].texture = curtexture;
	Klappa.db.profile.buttons[self.parent.index].popupButtons[self.index].spellID = slot;
	Klappa.db.profile.buttons[self.parent.index].popupButtons[self.index].spellName = spellName;
	Klappa.db.profile.buttons[self.parent.index].popupButtons[self.index].spelltype = spelltype;
	--Klappa.db.profile.buttons[self.index].texture = self.button.texture:GetTexture();
	ClearCursor();
end
