local _G = getfenv(0);
local dewdrop = AceLibrary("Dewdrop-2.0");
local tablet = AceLibrary("Tablet-2.0");
local L = AceLibrary("AceLocale-2.2"):new("Klappa");
---------------------
-- Options Support --
---------------------


function Klappa:InitOptions()
	local options = {
		type="group",   
		args = { 
			lock = {
				name = L["Lock the frame"],
				desc = L["Lock the frame"],
				type = "toggle",
				get = function() return Klappa.isLocked end,
				set = function(v) Klappa:ToggleLock() end,
				disabled = function() return InCombatLockdown() end,
			},
			
			add = {
				name = L["Add main button"],
				desc = L["Add a new main button"],
				type = "execute",
				func = function() Klappa:AddMainButton() end,
			},
			del = {
				name = L["Delete main button"],
				desc = L["Delete last main button"],
				type = "execute",
				func = function() Klappa:DelMainButton() end,
			},
				
			orientation = {
				type = "text",
				name = L["Orientation"],
				desc = L["Set the orientation of the Klappa Bar."],
				order = 1,
				get = function() return Klappa.db.profile.orient; end,
				set = function(v) Klappa.db.profile.orient = v; Klappa:UpdateLayout(); end,
				validate = { 
					["horzup"] = L["Horizontal, Grow Up"],
					["horzdown"] = L["Horizontal, Grow Down"],
					["vertright"] = L["Vertical, Grow Right"],
					["vertleft"] = L["Vertical, Grow Left"],
				},
			},
			
			mainScale = {
				type = "range",
				name = L["Main Scale"],
				desc = L["Scale the buttons"],
				order = 2,
				step = 0.05,
				min = 0.25,
				max = 5.0,
				isPercent = false,
				get = function() return Klappa.db.profile.buttonScale; end,
				set = function(v)
					Klappa.db.profile.buttonScale = v;
					Klappa.root:SetScale(v);
				end
			},
		}
	}

	return options;
end

function Klappa:InitStyles(input)
	
end

-------------
-- Profile --
-------------
function Klappa:InitProfile()

end
-----------
-- FuBar --
-----------


function Klappa:OnTextUpdate()
    
end

function Klappa:OnTooltipUpdate()
	
end
